#ifndef _WDL_STRING_H_
#define _WDL_STRING_H_

#include "heapbuf.h"

class WDL_String
{
public:
  WDL_String(const char *initial=NULL, int initial_len=0)
  {
    if (initial) Set(initial,initial_len);
  }
  ~WDL_String()
  {
  }

  void Set(const char *str, int maxlen=0)
  {
    int s=strlen(str);
    if (maxlen && s > maxlen) s=maxlen;   

    char *newbuf=(char*)m_hb.Resize(s+1);
    if (newbuf) 
    {
      memcpy(newbuf,str,s);
      newbuf[s]=0;
    }
  }

  void Append(const char *str, int maxlen=0)
  {
    int s=strlen(str);
    if (maxlen && s > maxlen) s=maxlen;

    int olds=m_hb.GetSize();
    if (olds > 0) olds--;

    char *newbuf=(char*)m_hb.Resize(olds + s + 1);
    if (newbuf)
    {
      memcpy(newbuf + olds, str, s);
      newbuf[olds+s]=0;
    }
  }

  void SetLen(int length) // sets number of chars allocated for string, not including null terminator
  {                       // can use to resize down, too, or resize up for a sprintf() etc
    char *b=(char*)m_hb.Resize(length+1);
    if (b) b[length]=0;
  }

  char *Get()
  {
    if (m_hb.Get()) return (char *)m_hb.Get();
    return "";
  }

  private:
    WDL_HeapBuf m_hb;
};

#endif